#include "U8glib.h"
//-------字体设置，大、中、小
#define setFont_L u8g.setFont(u8g_font_7x13)
#define setFont_M u8g.setFont(u8g_font_fixed_v0r)
#define setFont_S u8g.setFont(u8g_font_fixed_v0r)
/*
font:
 u8g_font_7x13
 u8g_font_fixed_v0r
 u8g_font_chikitar
 u8g_font_osb21
 u8g_font_courB14r
 u8g_font_courB24n
 u8g_font_9x18Br
 */
 //屏幕类型--------
U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);

static unsigned char playPic[][28] U8G_PROGMEM = {
{0x03,0x00,0x0F,0x00,0x3F,0x00,0xFF,0x00,0xFF,0x03,0xFF,0x0F,0xFF,0x3F,0xFF,0x3F,
0xFF,0x0F,0xFF,0x03,0xFF,0x00,0x3F,0x00,0x0F,0x00,0x01,0x00},

{0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,
0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F,0x3E,0x1F}  
};

static unsigned char modePic[][54] U8G_PROGMEM = {
{0x00,0x00,0x01,0x00,0x00,0x03,0xFC,0xFF,0x07,0xFE,0xFF,0x0F,0xFF,0xFF,0x0F,0xEF,
0x7F,0x07,0x07,0x00,0x03,0x07,0x00,0x0D,0x07,0x00,0x0E,0x07,0x00,0x0E,0x0B,0x00,
0x0E,0x0C,0x00,0x0E,0x0E,0x00,0x0F,0xFF,0xFF,0x0F,0xFF,0xFF,0x07,0xFE,0xFF,0x03,
0x0C,0x00,0x00,0x08,0x00,0x00},

{0x00,0x80,0x00,0x00,0x80,0x01,0xFE,0xFF,0x03,0xFF,0xFF,0x07,0xFF,0xFF,0x03,0xFF,
0xFF,0x03,0x07,0x80,0x01,0x07,0x80,0x01,0x07,0x00,0x00,0x07,0x80,0x03,0x0B,0xC0,
0x03,0x0C,0xC0,0x03,0xFE,0x3F,0x03,0xFF,0x3F,0x03,0xFF,0x3F,0x03,0xFE,0x3F,0x03,
0x0C,0x00,0x03,0x08,0x00,0x00},

{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x08,0x80,
0x01,0x18,0x80,0x03,0x38,0xFF,0xF7,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF7,
0x7F,0x80,0x03,0x38,0x80,0x01,0x18,0x80,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00}
};

//主界面，可自由定义
void drawUi(int file_num, int total_num, int mode, int vol, bool status, String name_cache, int play_time, int total_time)
{
  setFont_L;
  int play_min = play_time/60;
  int play_sec = play_time%60;
  int total_min = total_time/60;
  int total_sec = total_time%60;
  
  u8g.drawXBMP(68, 0, 24, 18, modePic[mode]); 
  u8g.drawXBMP(4, 38, 14, 14, playPic[status]);

  u8g.setPrintPos(4,16);
  if(file_num < 100){
     u8g.print("0");  
  }
  if(file_num < 10){
     u8g.print("0");  
  }
  u8g.print(file_num);
  u8g.print("/");
  if(total_num < 100){
     u8g.print("0");  
  }
  if(total_num < 10){
     u8g.print("0");  
  }
  u8g.print(total_num);    
  
  u8g.setPrintPos(100, 16);
  u8g.print("V:");
  u8g.print(vol);
  u8g.setPrintPos(4, 32 );
  u8g.print(name_cache);
  
  u8g.setPrintPos(46, 48);
  if(play_min < 10){
      u8g.print(0);
  }
  u8g.print(play_min);
  u8g.print(":");
  if(play_sec < 10){
      u8g.print(0);
  }
  u8g.print(play_sec);
  u8g.print("/");
  if(total_min < 10){
      u8g.print(0);
  }
  u8g.print(total_min);
  u8g.print(":");
  if(total_sec < 10){
      u8g.print(0);
  }
  u8g.print(total_sec);
  
  u8g.drawBox(0, 62, 128, 1);
  u8g.drawBox(0, 59, map(play_time,0,total_time,0,128), 3);
}

void UI(int file_num, int total_num, int mode, int vol, bool status, String name_cache, int play_time, int total_time){
    u8g.firstPage();  
    do {
      drawUi(file_num,total_num,mode,vol,status,name_cache,play_time,total_time);
    } 
    while(u8g.nextPage());
}

